Public Class Form1

    Public nt As noty
    ''' <summary>
    ''' Otevre ze souboru skladbu
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NastToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NastToolStripMenuItem.Click
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            nt = New noty
            Dim retVal As String = nt.Load(OpenFileDialog1.FileName)
            If retVal <> String.Empty Then
                MsgBox(retVal, MsgBoxStyle.Critical, "Chyba")
                Exit Sub
            End If
            posunX = 0
            Render(nt)
        End If
    End Sub


    ' GRAFIKA
    Dim takt(0 To 2) As Bitmap
    Dim pomlky(0 To 3) As Bitmap
    Dim klic As Bitmap

    Dim n(0 To 3, 0 To 3) As Bitmap

    Dim sizeOfNoty As Integer = 0
    Sub NactiGrafiku()
        Dim pth As String = Application.StartupPath & "\..\..\"

        takt(0) = New Bitmap(pth & "\img\" & sizeOfNoty & "\takt_3.png")
        takt(1) = New Bitmap(pth & "\img\" & sizeOfNoty & "\takt_4.png")
        takt(2) = New Bitmap(pth & "\img\" & sizeOfNoty & "\takt_5.png")

        pomlky(0) = New Bitmap(pth & "\img\" & sizeOfNoty & "\pomlka_0.png")
        pomlky(1) = New Bitmap(pth & "\img\" & sizeOfNoty & "\pomlka_1.png")
        pomlky(2) = New Bitmap(pth & "\img\" & sizeOfNoty & "\pomlka_2.png")
        pomlky(3) = New Bitmap(pth & "\img\" & sizeOfNoty & "\pomlka_4.png")

        klic = New Bitmap(pth & "\img\" & sizeOfNoty & "\klic.png")

        n(0, 0) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_nahoru_0.png")
        n(0, 1) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_krizek_nahoru_0.png")
        n(0, 2) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_dolu_0.png")
        n(0, 3) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_krizek_dolu_0.png")

        n(1, 0) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_nahoru_1.png")
        n(1, 1) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_krizek_nahoru_1.png")
        n(1, 2) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_dolu_1.png")
        n(1, 3) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_krizek_dolu_1.png")

        n(2, 0) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_nahoru_2.png")
        n(2, 1) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_krizek_nahoru_2.png")
        n(2, 2) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_dolu_2.png")
        n(2, 3) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_krizek_dolu_2.png")

        n(3, 0) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_4.png")
        n(3, 1) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_krizek_4.png")
        n(3, 2) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_4.png")
        n(3, 3) = New Bitmap(pth & "\img\" & sizeOfNoty & "\nota_krizek_4.png")

    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ListBox1.SelectedIndex = 0
    End Sub

    ' posun pri prohlizeni
    Private posunX As Integer

    ' pozice noticek
    Dim posBuffer As New Generic.List(Of Point)

    Sub Render(ByVal nt As noty)
        posBuffer = New Generic.List(Of Point)
        pb.Image = New Bitmap(pb.Width, pb.Height)
        Dim grp As Graphics = Graphics.FromImage(pb.Image)
        Dim px As Integer = posunX
        Dim py As Integer = pb.Image.Height / 2

        Dim gridY(0 To 4) As Integer
        For i As Integer = 0 To 4
            gridY(i) = py - takt(0).Height / 2 + (takt(0).Height / 4) * i - 1
            grp.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
            grp.DrawLine(New Pen(Color.Black, IIf(sizeOfNoty = 2, 2, 1)), 0, gridY(i), pb.Image.Width, gridY(i))
        Next
        Dim gridSize As Single = (takt(0).Height / 4)
        Dim gridTop As Integer = gridY(0)

        Dim posX As Integer = px
        ' klic
        grp.DrawImage(klic, New Rectangle(posX, py - klic.Height / 2, klic.Width, klic.Height))

        ' takt
        posX += klic.Width * 1.2
        grp.DrawImage(takt(nt.Takt - 3), New Rectangle(posX, py - takt(0).Height / 2, takt(nt.Takt - 3).Width, takt(nt.Takt - 3).Height))
        posX += takt(nt.Takt - 3).Width * 1.2

        ' oblocky - definice
        Dim pocatekOblX As Integer
        Dim TTL As Integer

        ' jednotlive elementy
        Dim ind As Single
        For Each elm As noty.elm In nt.skladba
            If elm.vyska = 0 Then
                ' pomlka
                Select Case elm.delka
                    Case 0.5
                        grp.DrawImage(pomlky(0), New Rectangle(posX, py - pomlky(0).Height / 2, pomlky(0).Width, pomlky(0).Height))
                    Case 1
                        grp.DrawImage(pomlky(1), New Rectangle(posX, py - pomlky(1).Height / 2, pomlky(1).Width, pomlky(1).Height))
                    Case 1.5
                        grp.DrawImage(pomlky(1), New Rectangle(posX, py - pomlky(1).Height / 2, pomlky(1).Width, pomlky(1).Height))
                        DrawDot(posX + pomlky(1).Width, py + pomlky(1).Height / 2 - gridSize / 2, grp)
                    Case 2
                        grp.DrawImage(pomlky(2), New Rectangle(posX, gridY(2) + 1 + IIf(sizeOfNoty = 2, 1, 0) - pomlky(2).Height, pomlky(2).Width, pomlky(2).Height))
                    Case 3
                        grp.DrawImage(pomlky(2), New Rectangle(posX, gridY(2) + 1 + IIf(sizeOfNoty = 2, 1, 0) - pomlky(2).Height, pomlky(2).Width, pomlky(2).Height))
                        DrawDot(posX + pomlky(2).Width, gridY(2) + 1 + IIf(sizeOfNoty = 2, 1, 0) - gridSize / 2, grp)
                    Case 4
                        grp.DrawImage(pomlky(3), New Rectangle(posX, gridY(1) - IIf(sizeOfNoty <> 0, 1, 0), pomlky(3).Width, pomlky(3).Height))
                End Select
            Else
                RenderNota(elm.vyska, elm.delka, posX, grp, gridSize, gridTop)
            End If

            ' obloucky
            If TTL <> 0 Then
                TTL -= 1
                If TTL = 0 Then
                    Dim x1 As Single = pocatekOblX
                    Dim y1 As Single = gridTop - gridSize * 2
                    Dim y2 As Single = gridTop - gridSize * 3
                    Dim x2 As Single = posX + n(0, 0).Width / 2
                    grp.DrawBezier(New Pen(Color.Black, IIf(sizeOfNoty = 2, 2, 1)), x1, y1, x1 + (x2 - x1) / 3, y2, x1 + ((x2 - x1) / 3) * 2, y2, x2, y1)
                End If
            End If

            If elm.skok <> 0 Then
                pocatekOblX = posX + n(0, 0).Width / 2
                TTL = elm.skok
            End If

            Dim oldPosX As Integer = posX

            ind = ind + elm.delka
            posX = posX + n(0, 0).Width * 1.35 * IIf(chDelka.Checked = True, (elm.delka + 0.5), 1)

            ' pridat do pozic pro editaci
            posBuffer.Add(New Point(oldPosX, posX))

            ' oddelovac
            If ind Mod 4 = 0 And ind <> 0 Then
                grp.DrawLine(New Pen(Color.Black, IIf(sizeOfNoty = 2, 2, 1)), posX, gridY(0), posX, gridY(4))
                posX = posX + n(0, 0).Width * 1.1
            End If
        Next

    End Sub

    ' vysky jednotlivych not
    Dim pozice() As Single = {4.5, 4.5, 4, 4, 3.5, 3, 3, 2.5, 2.5, 2, 2, 1.5, 1, 1, 0.5, 0.5, 0, -0.5, -0.5, -1, -1, -1.5, -1.5, 2}
    ' zda ma noticka krizek
    Dim krizek() As Boolean = {False, True, False, True, False, False, True, False, True, False, True, False, False, True, False, True, False, False, True, False, True, False, True, False}

    ' vykresleni noticky
    Sub RenderNota(ByVal index As Integer, ByVal doba As Single, ByVal posx As Integer, ByVal grp As Graphics, ByVal gridSize As Single, ByVal gridTop As Integer)
        Dim db As Integer
        Select Case doba
            Case 0.5
                db = 0
            Case 1
                db = 1
            Case 1.5
                db = 1
            Case 2
                db = 2
            Case 3
                db = 2
            Case 4
                db = 3
        End Select
        If doba > 4 Then Exit Sub
        If doba = 4 Then
            ' kolecko ( 4 doby )
            Dim i As Bitmap = n(db, IIf(krizek(index - 1), 1, 0))
            grp.DrawImage(i, New Rectangle(posx, (pozice(index - 1)) * gridSize + gridTop + IIf(krizek(index - 1), gridSize, 0), i.Width, i.Height))
        Else
            If index <= 12 Then
                ' nahoru
                Dim i As Bitmap = n(db, IIf(krizek(index - 1), 1, 0))
                grp.DrawImage(i, New Rectangle(posx, (pozice(index - 1)) * gridSize + gridTop - i.Height + gridSize * 1.2 + IIf(krizek(index - 1), gridSize, 0), i.Width, i.Height))
                If doba = 1.5 Or doba = 3 Then
                    DrawDot(posx + i.Width * 1.1, (pozice(index - 1)) * gridSize + gridTop + gridSize * 1.2 - gridSize / 1.5 - IIf(pozice(index - 1) <> Int(pozice(index - 1)) + IIf(krizek(index - 1), gridSize, 0), gridSize * 0.6, 0), grp)
                End If
            Else
                ' dolu 
                Dim i As Bitmap = n(db, IIf(krizek(index - 1), 3, 2))
                grp.DrawImage(i, New Rectangle(posx, (pozice(index - 1)) * gridSize + gridTop + IIf(krizek(index - 1), gridSize, 0), i.Width, i.Height))
            End If
        End If
        Dim pz As Single = pozice(index - 1) + 0.5
        If pz < 0 Or pz > 4.5 Then
            grp.DrawLine(New Pen(Color.Black, IIf(sizeOfNoty = 2, 2, 1)), CInt(posx + n(0, 0).Width * -0.1), gridTop + gridSize * pz + IIf(krizek(index - 1), gridSize, 0), CInt(posx + n(0, 0).Width * 1.1), CInt(gridTop + gridSize * pz))
        End If

    End Sub

    Private Sub Form1_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        ' prekreslime pri zmene velikosti okna
        If nt IsNot Nothing Then Render(nt)
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        ' zmenime velikost not
        sizeOfNoty = ListBox1.SelectedIndex
        ' znovu nacteme grafiku
        NactiGrafiku()
        ' a prekreslime
        If nt IsNot Nothing Then Render(nt)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

    End Sub

    Private Sub Button2_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button2.MouseDown
        tmr.Tag = -30
        tmr.Enabled = True
    End Sub

    Private Sub Button2_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button2.MouseUp
        tmr.Enabled = False
    End Sub

    Private Sub Button1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button1.MouseDown
        tmr.Tag = 30
        tmr.Enabled = True
    End Sub


    Private Sub Button1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button1.MouseUp
        tmr.Enabled = False
    End Sub

    Private Sub tmr_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmr.Tick
        posunX += tmr.Tag
        If nt IsNot Nothing Then Render(nt)
    End Sub

    Private Sub pb_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb.Click

    End Sub

    Private chyt As Integer
    Private Sub pb_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pb.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Right Then
            ' chytnout mysi
            chyt = e.X
        ElseIf e.Button = Windows.Forms.MouseButtons.Left Then
            ' oznaceni
            If nt Is Nothing Then Exit Sub
            If posBuffer.Count = 0 Then Exit Sub
            Dim ind As Integer = 0
            For Each p As Point In posBuffer
                If p.X <= e.X And p.Y >= e.X Then
                    ind = -ind
                    Exit For
                End If
                ind = ind - 1
            Next
            If ind >= 0 Then
                If rdb1.Checked = True Then
                    nt.skladba.RemoveAt(ind)
                    Render(nt)
                End If
            End If
        End If
    End Sub

    Private Sub pb_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pb.MouseMove
        ' pusun mysi
        If e.Button = Windows.Forms.MouseButtons.Right Then
            posunX += e.X - chyt
            chyt = e.X
            If nt IsNot Nothing Then Render(nt)
        End If
    End Sub

    Private Sub DrawDot(ByVal posX As Integer, ByVal top As Integer, ByVal grp As Graphics)
        grp.FillEllipse(Brushes.Black, New RectangleF(posX - 1, top - 1 - sizeOfNoty, sizeOfNoty + 2, sizeOfNoty + 2))
    End Sub

    Private Sub chDelka_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chDelka.CheckedChanged
        If nt IsNot Nothing Then Render(nt)
    End Sub

    Private Sub UloitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UloitToolStripMenuItem.Click
        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim retVal As String = nt.Save(SaveFileDialog1.FileName)
            If retVal <> String.Empty Then
                MsgBox(retVal, MsgBoxStyle.Critical, "Chyba")
                Exit Sub
            End If
        End If
    End Sub
End Class
